#ifndef I2CLib
#define I2CLib

#include <stdint.h>
#include <avr/io.h>

#define F_SCL 100000UL // SCL frequency
#define TWBR_val (((F_CPU / F_SCL) - 16 ) / 2)

void I2C_Init();
void I2C_Start();
void I2C_Stop(void);
void I2C_Write(uint8_t v_i2cData_u8);
uint8_t I2C_Read(uint8_t v_ackOption_u8);

void I2C_Init()
{
//    TWSR = (bit_PS1 << TWPS1) | (bit_PS0 << TWPS0); // Установка предделителя
    TWSR=0x00; //set presca1er bits to zero
    TWBR = TWBR_val; // Установка скорости передачи
    TWCR = (1 << TWEN); // Включение модуля TWI
}

void I2C_Start()
{
	TWCR = ((1<<TWINT) | (1<<TWSTA) | (1<<TWEN));
	while (!(TWCR & (1<<TWINT)));
}

void I2C_Stop(void)
{
	TWCR = ((1<< TWINT) | (1<<TWEN) | (1<<TWSTO));
	_delay_us(100) ; //wait for a short time
}

void I2C_Write(uint8_t v_i2cData_u8)
{
	TWDR = v_i2cData_u8 ;
	TWCR = ((1<< TWINT) | (1<<TWEN));
	while (!(TWCR & (1 <<TWINT)));
}

uint8_t I2C_Read(uint8_t v_ackOption_u8)
{
	TWCR = ((1<< TWINT) | (1<<TWEN) | (v_ackOption_u8<<TWEA));
	while ( !(TWCR & (1 <<TWINT)));
	return TWDR;
}

#endif
