#include <stdint.h>
#include <avr/io.h>

// Функция для инициализации АЦП
void adc_init() {
    // Устанавливаем опорное напряжение на AVCC и выбираем канал ADC0
//    ADMUX = (1 << REFS0);
    // Устанавливаем внутренний источник опорного напряжения (1.1 В)
    ADMUX = (1 << REFS1) | (1 << REFS0);

    // Включаем АЦП и устанавливаем предделитель на 128 (частота 125 кГц при 16 МГц)
    ADCSRA = (1 << ADEN) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0);
}

// Функция для чтения значения АЦП
uint16_t adc_read(uint8_t channel) {
    // Выбираем канал (0-7) и очищаем старшие биты
    ADMUX = (ADMUX & 0xF0) | (channel & 0x0F);

    // Запускаем преобразование
    ADCSRA |= (1 << ADSC);

    // Ждем завершения преобразования
    while (ADCSRA & (1 << ADSC));

    // Возвращаем результат
    return ADC;
}

